/* ***********************************************************************
 *
 *  ubit.hpp: includes all common Ubit headers 
 *  Ubit GUI Toolkit - Version 6
 *  (C) 2009 | Eric Lecolinet | TELECOM ParisTech | http://www.enst.fr/~elc/ubit
 *
 * ***********************************************************************
 * COPYRIGHT NOTICE : 
 * THIS PROGRAM IS DISTRIBUTED WITHOUT ANY WARRANTY AND WITHOUT EVEN THE 
 * IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 
 * YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF THE GNU 
 * GENERAL PUBLIC LICENSE AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION; 
 * EITHER VERSION 2 OF THE LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
 * SEE FILES 'COPYRIGHT' AND 'COPYING' FOR MORE DETAILS.
 * ***********************************************************************/

#ifndef _ubit_hpp_
#define	_ubit_hpp_ 1

// udefs.hpp includes <ubit/ubit_features.h> that defines defines crucial compilation options
// and is generated by 'configure' or 'umake' (which are in the Ubit base directory).
#include <ubit/udefs.hpp>
#include <ubit/uobject.hpp>
#include <ubit/unode.hpp>
#include <ubit/ulength.hpp>
#include <ubit/ugeom.hpp>
#include <ubit/unumber.hpp>

#include <ubit/uattr.hpp>
#include <ubit/uboxgeom.hpp>
#include <ubit/uborder.hpp>
#include <ubit/ubackground.hpp>
#include <ubit/ucolor.hpp>
#include <ubit/ucursor.hpp>
#include <ubit/uedit.hpp>
#include <ubit/ufont.hpp>

#include <ubit/uon.hpp>
#include <ubit/ucall.hpp>

#include <ubit/udata.hpp>
#include <ubit/ustr.hpp>
#include <ubit/usymbol.hpp>
#include <ubit/uima.hpp>
#include <ubit/upix.hpp>

#include <ubit/uelem.hpp>
#include <ubit/ubox.hpp>
#include <ubit/uboxes.hpp>
#include <ubit/uwin.hpp>
#include <ubit/udialogs.hpp>
#include <ubit/umenu.hpp>
#include <ubit/uctlmenu.hpp>
#include <ubit/uinteractors.hpp>
#include <ubit/uscrollpane.hpp>
#include <ubit/uscrollbar.hpp>
#include <ubit/uslider.hpp>
#include <ubit/utable.hpp>
#include <ubit/uchoice.hpp>
#include <ubit/ufilebox.hpp>
#include <ubit/ulistbox.hpp>
#include <ubit/upalette.hpp>
#include <ubit/utreebox.hpp>

#include <ubit/uzoom.hpp>
#include <ubit/uglcanvas.hpp>
#include <ubit/u3d.hpp>

#include <ubit/uappli.hpp>
#include <ubit/udisp.hpp>
#include <ubit/uevent.hpp>
#include <ubit/ukey.hpp>
#include <ubit/uview.hpp>
#include <ubit/ufontmetrics.hpp>
#include <ubit/uupdate.hpp>
#include <ubit/uupdatecontext.hpp>
#include <ubit/ugraph.hpp>
#include <ubit/uconf.hpp>
#include <ubit/ustyle.hpp>
#include <ubit/utimer.hpp>
#include <ubit/usource.hpp>
#include <ubit/ueventflow.hpp>
#include <ubit/uselection.hpp>
#include <ubit/ufile.hpp>

#endif

