/* ==================================================== ======== ======= *
 *
 *  upixmaps.hpp
 *  a wrapping for using some of the great FVWM pixmaps in the Ubit toolkit
 *  
 *  !!NOTE that this file is usually unnecessary for building Ubit applications.
 *  These pixmaps are already declared as UPix constants in the upix.hh file
 *
 * ==================================================== ======== ======= */
/*
Mini XPM icon package (for fvwm).
Version 1
Free (F) by Ludvig A. Norin 1995
emph@ludd.luth.se

This package contains 14x14 pixel icons
for use with the FVWM 2.x distribution.
The icons might of course be used in just
about any other purpose you can think of,
but since FVWM is such a great wm, I
really suggest that you use them in it,
rather than putting them in your private
.JPG/.GIF pictures just for the fun of it.

The icons are small enough to give the
FVWM menus a spiffy outlook. The icons
are optimized to use as few colors as
possible, and they will totally occypy
14 entrys of the colormap.
*/

namespace ubit {

  struct UXpm {
    static const char * metal[];
    static const char * velin[];
    static const char * bricks[];
    static const char * folder[];
    static const char * ofolder[];
    static const char * doc[];
    static const char * diskette[];
    static const char * question[];
    static const char * ray[];
    static const char * link[];
    static const char * undo[];
    static const char * select[];
    static const char * cross[];
    static const char * left[];
    static const char * rball[];
    static const char * right[];
    static const char * raise[];
    static const char * lower[];
    static const char * plus[];
    static const char * minus[];
    static const char * ellipsis[];
    static const char * zoom[];
    static const char * resize[];
    static const char * windows[];
    static const char * edit[];
    static const char * bomb[];
    static const char * clock[];
    static const char * book[];
    static const char * colors[];
    static const char * eyes[];
    static const char * mail[];
    static const char * paint[];
    static const char * stop[];
    static const char * palette[];
    static const char * term[];
    static const char * camera[];
    static const char * leftarrow[];
    static const char * rightarrow[];
    static const char * uparrow[];
    static const char * downarrow[];
    static const char * hslider[];
    static const char * vslider[];
    static const char * bigFolder[];
    static const char * bigDoc[];
    static const char * bigText[];
    static const char * bigIma[];
    static const char * bigUp[];
    static const char * bigDown[];
    static const char * bigLeft[];
    static const char * bigRight[];
    static const char * bigPlus[];
    static const char * bigMinus[];
    static const char * bigQuestion[];
     };
}

