#!/bin/sh

prefix=/usr/local
exec_prefix=${prefix}
exec_prefix_set=no

LIBS="-lxpm -lungif -ljpeg"

usage="\
Usage: ubit-config [--prefix] [--exec-prefix] [--version] [--libs] [--cflags] [--help]"

if test $# -eq 0; then
      echo "${usage}" 1>&2
      exit 1
fi

while test $# -gt 0; do
  case "$1" in
  -*=*) optarg=`echo "$1" | sed 's/[-_a-zA-Z0-9]*=//'` ;;
  *) optarg= ;;
  esac

  case $1 in
    --prefix=*)
      prefix=$optarg
      if test $exec_prefix_set = no ; then
        exec_prefix=$optarg
      fi
      ;;
    --prefix)
      echo $prefix
      ;;
    --exec-prefix=*)
      exec_prefix=$optarg
      exec_prefix_set=yes
      ;;
    --exec-prefix)
      echo $exec_prefix
      ;;
    --version)
      echo 7.0.0
      ;;
    --cflags)
      if test ${prefix}/include != /usr/include ; then
        includes=-I${prefix}/include
      fi
      echo $includes
      ;;
    --libs)
      echo "${LIBS} -L${exec_prefix}/lib -lubit"
      ;;
    --help)
      echo "${usage}" 1>&2
      exit 0
      ;;
    *)
      echo "${usage}" 1>&2
      exit 1
      ;;
  esac
  shift
done
