#!/bin/sh
# CONFIGURATION OF THE UBIT PROJECT


# !!! WARNING: NO white spaces and "" are neededÈ
CC="gcc"               # C Compiler
CXX="g++"              # C++ Compiler
CFLAGS="-g -Wall"      # C Compiler Options
CXXFLAGS="-g -Wall"    # C++ Compiler Options
BUILD_DIR="$PWD/.."
INSTALL_DIR="$PWD/.."


if [ "$1" = "" ]
then
  echo "Which windowing toolkit you want to use X11 ou GLUT?"
  echo "You can either:"
  echo "- start again with the toolkit name as an argument"
  echo "- enter the toolkit name then press the ENTER key"
  read WIN_TOOLKIT
else
  WIN_TOOLKIT="$1"
fi

case $WIN_TOOLKIT in
  "GLUT") WIN_TOOLKIT="GLUT" ;;
  "X11")  WIN_TOOLKIT="X11" ;;
  *) echo "!!! Error: '"$WIN_TOOLKIT"' is not available, only X11 or GLUT are possible values!"
  echo "!!! Start again"
  echo ""
  exit 1 ;;
esac

echo ""
echo "WIN_TOOLKIT:" $WIN_TOOLKIT
echo ""

export WIN_TOOLKIT CC CXX CFLAGS CXXFLAGS BUILD_DIR INSTALL_DIR

echo "Compiling the configuration file 'umake/CONFIG.cpp'"
echo "Please wait..."

$CXX CONFIG.cpp umake.cpp -o CONFIG
status=$?

if [ "$status" != 0 ]
then
  echo ""
  echo "!!! The configuration file could not be compiled:"
  echo "!!! - Please correct 'umake/CONFIG.cpp' then start again"
  exit 1
fi

echo "Creating the Makefiles and the 'ubit_features.h' header..."
echo " "

/bin/rm -f CONFIG.log
./CONFIG CONFIG.cpp CONFIG.log 2> CONFIG.log
status=$?
echo ""

if [ "$status" != 0 ]
then
  exit 1
fi

/bin/rm lib_status lib_tst.c lib_tst 2> /dev/null
